%% Calculating Emission PSF when under RIM
%% plotting output
% draw anything? y/n
fig0=1;
% draw 2D PSF sections - ?
fig=1;
%% define the RIM geometry
NA=1.4;
%objective is DESIGNED for the conditions:
    % 1) refractive indexes the objective is supposed to work with
    n1=[1.52 1.52 1.52];
    % 2) thikneses of layers before focus, micrometers
    d1=[300 170 0];     
% the actual RIM conditions:
    % 1) in the sample with refractive indexes of
    n2=[n1(1) n1(2) 1.33];
    % 2) object is burried that deep into the last layer, micrometers
    z_A=50;
    % 3) the thiknesses of layers befrore the object
    d2=[d1(1)-z_A*n1(end)/n2(end)... % paraxial estimate used to shift the frame
        d1(2) z_A];
%% define emission wavelength
lambda=0.55;% micrometers
    % can integrate over wavelengthes:
    % lambda=(.533:0.001:.57);
    % to do scalar computaion (to demonstrate the principles)  use negative
    % lambda=-0.55; 
%% define discretisation
% field -- number of the rays/Bessel-beam modes
M=2000;
% pixels in PSF
N=3072;
% axial range (z_N) of PSF computation
Dz=20;
% lateral range of PSF computation
Dy=5; 
%% The computation itself is performed in a different m-file, but the same workspace
Compute_Diffraction_Integral

%% finding the focal position 
Prof1D_Em=Prof2D_Em(:,1);

[~,i]=max(abs(Prof1D_Em));% position of the brightest pixel
disp(['Max NFP focus at ', num2str(z_local(i)), 'um relative to paraxial estimate'])
% center of mass estimate
n_c=32;%half/width used for the esitmate, pixels
z_mean=sum(z_local((i-n_c+1):(i+n_c))'.*(abs(Prof1D_Em((i-n_c+1):(i+n_c))).^2))...
    /sum(abs(Prof1D_Em((i-n_c+1):(i+n_c))).^2);
disp(['Mean NFP focus at ', num2str(z_mean), 'um relative to paraxial estimate'])
%% axial plots or 2D profiles
if fig0
     %% 1D profile
    figure(1);
    plot(z_mean*[1 1],[0 1],'k','LineStyle','--','LineWidth',1);hold on;
    plot(z_local,abs(Prof1D_Em).^2/(max(abs(Prof1D_Em).^2)) ,'LineWidth',2);   %N/2+1
    title('(emission)^2')
    xlabel('z, \mum');ylabel('Intensity, a.u.');grid on;
    axis([z_local(i)-Dz/2 z_local(i)+Dz/2 0 +1]);
    f=gca;f.FontSize=14;
if fig==1
    %% 2D profile
    %coordinates
    [Z,Y]=meshgrid(z_local',y');
    figure(2);
    surf(Z,Y,abs(Prof2D_Em)','LineStyle','none');%
   view(2);colormap(gray);axis([ min(z_local) max(z_local) min(y) max(y)])
    xlabel('z, \mum');ylabel('Lateral coordinate, \mum');title('Emission Amplitude')
    f=gca;f.FontSize=14;
end
end

disp(['Amplitude: ', num2str(max(abs(Prof1D_Em)),'%10.2e') ])%N/2+1
