%% program to analyze the phase function Phi for a differnt scaling factor choices
% works in the workspace left after Emisson_PSF_under_RIM is finished
% To get a grip on the plots, start from larger depth, and go shallow (like z_A= 100 , 50, 20, 10 ... um)
figure(4);clf;grid on;hold on;
%% Several ways to visiulize interference, and critical points role

% Phase function value, relative to paraxial value
% demo_fun=@(x)(x-x(1));
% Same as above, but only parts within [-pi, pi] are shown
demo_fun=@(x)(x-x(1))./double((x-x(1))<pi)./double((x-x(1))>-pi);%
% Cos of phase function, relative to paraxial value
% demo_fun=@(x)cos(x-x(1));
% Fresnel-style integral
% demo_fun=@(x)abs(cumsum(exp(1i*(x))));

%% grab k from Emisson_PSF_under_RIM
k1=k_z(end,:);k2=real(k_z2(end,:));

Phi_fun=@(z1,z2) 2*pi/l*(k1*z1-k2*z2);
%% paraxial focus
z_nfp=z_A*(n1(end)/n2(end));

plot(k_r,demo_fun(Phi_fun(z_nfp,z_A)),'LineWidth',3)

%% Diel median focus
z_nfp=(z_A/((n2(end)^2-(NA/2)^2)./(1-(NA/2)^2)).^0.5);

plot(k_r,demo_fun(Phi_fun(z_nfp,z_A)),'LineWidth',3)

%% Liyakin co-median focus
k_liyakin2=0.5*(k2(1)+k2(end));
k_liyakin1=real((1-(n2(end)^2-k_liyakin2^2))^0.5);

z_nfp=(z_A/(k_liyakin2/k_liyakin1));

plot(k_r,demo_fun(Phi_fun(z_nfp,z_A)),'LineWidth',3)

%% real focus from PSF calculator itself
z_nfp=z_A*n1(end)/n2(end)+z_mean;

plot(k_r,demo_fun(Phi_fun(z_nfp,z_A)),'k','LineWidth',3)
%% variable zeta explicit formula
epsilon=(l/4)./(n2(end)*z_A)*sign(n2(end)-n1(end));
m=((n2(end)^2-n1(end)^2)^0.5);

dzeta_univ=n2(end)/n1(end)*((1-epsilon)+1/n1(end)*m*(epsilon.*(2-epsilon)).^.5)...
                        ./(1-(n2(end)/n1(end))^2*epsilon.*(2-epsilon));
dzeta_crit=(n1(end)-(n1(end)^2-NA^2)^.5)/(n2(end)-(n2(end)^2-NA^2)^.5);

dzeta_th=dzeta_univ;
if n1(end)<n2(end)
    dzeta_th(dzeta_univ>dzeta_crit)=dzeta_crit;
else
    dzeta_th(dzeta_univ<dzeta_crit)=dzeta_crit;
end

plot(k_r,demo_fun(Phi_fun(z_A/dzeta_th,z_A)),'k','LineStyle','--','LineWidth',3)
%% legend
% figure(2);
title(['\Phi behaviour depending on scaling chosen: NA=',num2str(NA),', n_1=',num2str(n1(end)),...
    ', n_2=',num2str(n2(end)),', z_A=',num2str(z_A),' \mum'])
legend('Paraxial','Diel median','Liyakin co-median','Actual focus',...
    'Variable \zeta','Location','best');
h=gca;h.FontSize=14;grid on;
xlabel('k_r/k_0');
ylabel('\Phi-\Phi(0)')